



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ES 10 - Elasticsearch的索引别名和索引模板</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ES 10 - Elasticsearch的索引别名和索引模板</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 14:23:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><div>
<div>目录</div>
<ul><li><a href="#1--什么是索引模板" rel="external nofollow noreferrer">1  什么是索引模板</a>
<ul><li><a href="#11--索引模板中的内容" rel="external nofollow noreferrer">1.1  索引模板中的内容</a></li>
<li><a href="#12--索引模板的用途" rel="external nofollow noreferrer">1.2  索引模板的用途</a></li></ul></li>
<li><a href="#2--创建索引模板" rel="external nofollow noreferrer">2  创建索引模板</a></li>
<li><a href="#3--查看索引模板" rel="external nofollow noreferrer">3  查看索引模板</a></li>
<li><a href="#4--删除索引模板" rel="external nofollow noreferrer">4  删除索引模板</a></li>
<li><a href="#5--模板的使用建议" rel="external nofollow noreferrer">5  模板的使用建议</a>
<ul><li><a href="#51--一个index中不能有多个type" rel="external nofollow noreferrer">5.1  一个index中不能有多个type</a></li>
<li><a href="#52--设置_source--false" rel="external nofollow noreferrer">5.2  设置_source = false</a></li>
<li><a href="#53--设置_all--false" rel="external nofollow noreferrer">5.3  设置_all = false</a></li>
<li><a href="#54--设置dynamic--strict" rel="external nofollow noreferrer">5.4  设置dynamic = strict</a></li>
<li><a href="#55--使用keyword类型" rel="external nofollow noreferrer">5.5  使用keyword类型</a></li></ul></li>
<li><a href="#参考资料" rel="external nofollow noreferrer">参考资料</a></li>
<li><a href="#版权声明" rel="external nofollow noreferrer">版权声明</a></li></ul>
</div>
<h1>1  什么是索引模板</h1>
<blockquote><p>索引模板: 就是把已经创建好的某个索引的参数设置(settings)和索引映射(mapping)保存下来作为模板, 在创建新索引时, 指定要使用的模板名, 就可以直接重用已经定义好的模板中的设置和映射.</p></blockquote>
<h2>1.1  索引模板中的内容</h2>
<p>(1)  settings: 指定index的配置信息, 比如分片数、副本数, tranlog同步条件、refresh策略等信息;</p>
<p>(2)  mappings: 指定index的内部构建信息, 主要有:</p>
<blockquote><p>① <code>_all</code>: All Field字段, 如果开启, <code>_all</code>字段就会把所有字段的内容都包含进来,检索的时候可以不用指定字段查询 —— 会检索多个字段, 设置方式: <code>&quot;_all&quot;: {&quot;enabled&quot;: true}</code>;</p>
<blockquote><p>在ES 6.0开始, <code>_all</code>字段被禁用了, 作为替换, 可以通过<code>copy_to</code>自定义实现all字段的功能.</p></blockquote>
<p>② <code>_source</code>: Source Field字段, ES为每个文档都保存一份源数据, 如果不开启, 也就是<code>&quot;_source&quot;: {&quot;enabled&quot;: false}</code>, 查询的时候就只会返回文档的ID, 其他的文档内容需要通过Fields字段到索引中再次获取, 效率很低. 但若开启, 索引的体积会更大, 此时就可以通过Compress进行压缩, 并通过<code>inclueds</code>、<code>excludes</code>等方式在field上进行限制 —— 指定义允许哪些字段存储到<code>_source</code>中, 哪些不存储;</p>
<p>③ <code>properties</code>: <strong>最重要的配置</strong>, 是对索引结构和文档字段的设置.</p></blockquote>
<h2>1.2  索引模板的用途</h2>
<p><strong>索引模板一般用在时间序列相关的索引中.</strong></p>
<p>—— 也就是说, 如果你需要每间隔一定的时间就建立一次索引, 你只需要配置好索引模板, 以后就可以直接使用这个模板中的设置, 不用每次都设置settings和mappings.</p>
<p><strong>索引模板一般与索引别名一起使用.</strong> 关于索引别名, 后续研究之后再做补充.</p>
<h1>2  创建索引模板</h1>
<p>创建一个商品的索引模板的示例:</p>
<p>(1) ES 6.0之前的版本:</p>
<pre class="prettyprint linenums"><code>PUT _template/shop_template<br />
{<br />
    &quot;template&quot;: &quot;shop*&quot;,       // 可以通过&quot;shop*&quot;来适配<br />
    &quot;order&quot;: 0,                // 模板的权重, 多个模板的时候优先匹配用, 值越大, 权重越高<br />
    &quot;settings&quot;: {<br />
        &quot;number_of_shards&quot;: 1  // 分片数量, 可以定义其他配置项<br />
    },<br />
    &quot;aliases&quot;: {<br />
        &quot;alias_1&quot;: {}          // 索引对应的别名<br />
    },<br />
    &quot;mappings&quot;: {<br />
        &quot;_default&quot;: {          // 默认的配置, ES 6.0开始不再支持<br />
            &quot;_source&quot;: { &quot;enabled&quot;: false },  // 是否保存字段的原始值<br />
            &quot;_all&quot;: { &quot;enabled&quot;: false },     // 禁用_all字段<br />
            &quot;dynamic&quot;: &quot;strict&quot;               // 只用定义的字段, 关闭默认的自动类型推断<br />
        },<br />
        &quot;type1&quot;: {             // 默认的文档类型设置为type1, ES 6.0开始只支持一种type, 所以这里不需要指出<br />
        */<br />
            &quot;_source&quot;: {&quot;enabled&quot;: false},<br />
            &quot;properties&quot;: {        // 字段的映射<br />
                &quot;@timestamp&quot;: {    // 具体的字段映射<br />
                    &quot;type&quot;: &quot;date&quot;,<br />
                    &quot;format&quot;: &quot;yyyy-MM-dd HH:mm:ss&quot;<br />
                },<br />
                &quot;@version&quot;: {<br />
                    &quot;doc_values&quot;: true,<br />
                    &quot;index&quot;: &quot;not_analyzed&quot;,  // 不索引<br />
                    &quot;type&quot;: &quot;string&quot;          // string类型<br />
                },<br />
                &quot;logLevel&quot;: {<br />
                    &quot;type&quot;: &quot;long&quot;<br />
                }<br />
            }<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>(2) ES 6.0之后的版本:</p>
<pre class="prettyprint linenums"><code>PUT _template/shop_template<br />
{<br />
    &quot;index_patterns&quot;: [&quot;shop*&quot;, &quot;bar*&quot;],       // 可以通过&quot;shop*&quot;和&quot;bar*&quot;来适配, template字段已过期<br />
    &quot;order&quot;: 0,                // 模板的权重, 多个模板的时候优先匹配用, 值越大, 权重越高<br />
    &quot;settings&quot;: {<br />
        &quot;number_of_shards&quot;: 1  // 分片数量, 可以定义其他配置项<br />
    },<br />
    &quot;aliases&quot;: {<br />
        &quot;alias_1&quot;: {}          // 索引对应的别名<br />
    },<br />
    &quot;mappings&quot;: {<br />
        // ES 6.0开始只支持一种type, 名称为“_doc”<br />
        &quot;_doc&quot;: {<br />
            &quot;_source&quot;: {            // 是否保存字段的原始值<br />
                &quot;enabled&quot;: false<br />
            },<br />
            &quot;properties&quot;: {        // 字段的映射<br />
                &quot;@timestamp&quot;: {    // 具体的字段映射<br />
                    &quot;type&quot;: &quot;date&quot;,<br />
                    &quot;format&quot;: &quot;yyyy-MM-dd HH:mm:ss&quot;<br />
                },<br />
                &quot;@version&quot;: {<br />
                    &quot;doc_values&quot;: true,<br />
                    &quot;index&quot;: &quot;false&quot;,   // 设置为false, 不索引<br />
                    &quot;type&quot;: &quot;text&quot;      // text类型<br />
                },<br />
                &quot;logLevel&quot;: {<br />
                    &quot;type&quot;: &quot;long&quot;<br />
                }<br />
            }<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>说明:</p>
<blockquote><p><strong>直接修改mapping的优先级 &gt; 索引模板中的设置</strong>;</p>
<p>索引匹配了多个template, 当属性等配置出现不一致时, 以模板的权重(order属性的值)为准, 值越大越优先, order的默认值是0.</p>
<p>ES 6.0之后的版本API变化较大, 请重点关注.</p></blockquote>
<h1>3  查看索引模板</h1>
<p>(1)  查看示例:</p>
<pre class="prettyprint linenums"><code>GET _template                // 查看所有模板<br />
GET _template/temp*          // 查看与通配符相匹配的模板<br />
GET _template/temp1,temp2    // 查看多个模板<br />
GET _template/shop_template  // 查看指定模板<br />
</code></pre>
<p>(2)  判断模板是否存在:</p>
<p>判断示例:</p>
<pre class="prettyprint linenums"><code>HEAD _template/shop_tem<br />
</code></pre>
<p>结果说明:</p>
<blockquote><p>a) 如果存在, 响应结果是: <code>200 - OK</code><br /><br />
b) 如果不存在, 响应结果是: <code>404 - Not Found</code></p></blockquote>
<h1>4  删除索引模板</h1>
<p>删除示例:</p>
<pre class="prettyprint linenums"><code>DELETE _template/shop_template	// 删除上述创建的模板<br />
</code></pre>
<p>如果模板不存在, 将抛出如下错误:</p>
<pre class="prettyprint linenums"><code>{<br />
  &quot;error&quot; : {<br />
    &quot;root_cause&quot; : [<br />
      {<br />
        &quot;type&quot; : &quot;index_template_missing_exception&quot;,<br />
        &quot;reason&quot; : &quot;index_template [shop_temp] missing&quot;<br />
      }<br />
    ],<br />
    &quot;type&quot; : &quot;index_template_missing_exception&quot;,<br />
    &quot;reason&quot; : &quot;index_template [shop_temp] missing&quot;<br />
  },<br />
  &quot;status&quot; : 404<br />
}<br />
</code></pre>
<h1>5  模板的使用建议</h1>
<h2>5.1  一个index中不能有多个type</h2>
<p>—— Elasticsearch 6.X版本中已经不支持在同一个index下创建多个type.</p>
<blockquote><p>6.X之前的版本中, 父子文档的实现是一个索引中定义多个type, 6.X中实现方式改变为join方式.</p></blockquote>
<p>如果在同一个index下创建多个type, 会报出如下错误信息:</p>
<pre class="prettyprint linenums"><code>{<br />
  &quot;error&quot;: {<br />
    &quot;root_cause&quot;: [<br />
      {<br />
        &quot;type&quot;: &quot;illegal_argument_exception&quot;,<br />
        &quot;reason&quot;: &quot;Rejecting mapping update to [book_shop] as the final mapping would have more than 1 type: [books, novel_book]&quot;<br />
      }<br />
    ],<br />
    &quot;type&quot;: &quot;illegal_argument_exception&quot;,<br />
    &quot;reason&quot;: &quot;Rejecting mapping update to [book_shop] as the final mapping would have more than 1 type: [books, novel_book]&quot;<br />
  },<br />
  &quot;status&quot;: 400<br />
}<br />
</code></pre>
<p>错误信息指出: 拒绝对[book_shop]的mapping信息进行修改, 因为它作为final mapping(终态的mapping), 将会有超过2个type.</p>
<h2>5.2  设置_source = false</h2>
<p>如果我们只关心查询的评分结果, 而不用查看原始文档的内容, 就设置<code>&quot;_source&quot;: {&quot;enabled&quot;: false}</code>.</p>
<p>—— 这能节省磁盘空间并减少磁盘IO上的开销.</p>
<blockquote><p>我们可以把原始的数据存储在MySQL、HBase等数据库, 从ES中得到文档的ID之后, 再到相应的数据库中获取数据.</p></blockquote>
<h2>5.3  设置_all = false</h2>
<p>如果能够确切地知道要对哪个field做查询操作, 就设置<code>&quot;_all&quot;: {&quot;enabled&quot;: false}</code>.</p>
<p>—— 这能实现性能提升, 并节省存储空间.<br /><br />
而在6.X版本开始, <code>_all</code>字段也不再支持了, ES官方建议我们通过<code>copy_to</code>自定义我们自己的all字段.</p>
<h2>5.4  设置dynamic = strict</h2>
<p>如果我们的数据是结构化数据, 就设置<code>&quot;dynamic&quot;: &quot;strict&quot;</code>.</p>
<p>—— 把动态类型判断设置为严格, 也就是不允许ES为插入的数据进行动态类型设置, 避免注入脏数据.</p>
<h2>5.5  使用keyword类型</h2>
<p>如果我们只关心精确匹配, 就设置<code>test_field: {&quot;type&quot;: &quot;keyword&quot;}</code>.</p>
<p>—— keyword类型要比text类型的性能更高, 并且还能节省磁盘的存储空间.</p>

<blockquote><h1>参考资料</h1>
<p><a href="https://www.elastic.co/guide/en/elasticsearch/reference/6.6/indices-templates.html" rel="external nofollow noreferrer">官方文档(6.6) - Index Templates</a></p>
<p><a href="https://www.jianshu.com/p/1f67e4436c37" rel="external nofollow noreferrer">初探 Elasticsearch Index Template（索引模板)</a></p>
<p><a href="https://www.cnblogs.com/zlslch/p/6478168.html" rel="external nofollow noreferrer">Elasticsearch之索引模板index template与索引别名index alias</a></p></blockquote>
<blockquote><h1>版权声明</h1>
<p>作者: <a href="https://healchow.com" rel="external nofollow noreferrer">瘦风(https://healchow.com)</a></p>
<p>出处: 博客园 <a href="https://www.cnblogs.com/shoufeng" rel="external nofollow noreferrer">瘦风(https://www.cnblogs.com/shoufeng)</a></p>
<p>感谢阅读, 如果文章有帮助或启发到你, 点个[<a>好文要顶												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1z0249.html">ASP&period;NET MVC Filter- 登录验证 【异步刷新列表视图】</a>
		</li>
						<li><a href="https://www.batexi.com/a/495p3w6q.html">Another app is currently holding the yum lock</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p2rod8.html">优秀工具推荐：两款很棒的 HTML5 游戏开发工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxverj9.html">C&num;中服务端接受前端JSON字符串转换成字典集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o05p49.html">erlang远程加载模块须知</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xp04w9.html">backgroundworker的使用问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1ze7oq.html">Quick Cocos2dx Http通讯</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpd5rjq.html">iOS开发&mdash;&mdash;打包静态库与Framework</a>
		</li>
						<li><a href="https://www.batexi.com/a/90men5n8.html">iOS开发之Run Loop</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljweox9.html">【PL&sol;SQL Developer】动态执行表不可访问，本会话的自动统计被禁止</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zepln9.html">Git服务器安装详解及安装遇到问题解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwwyn8.html">IDEA启动项目内存溢出</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvvoxx8.html">CSS盒模型及边距问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rpp139.html">PAT基础6-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j162pe9.html">&lbrack;模板&rsqb;&lbrack;P3808&rsqb;AC自动机&lpar;简单版&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw561y8.html">eslint 代码检测工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvx3kj8.html">js 复制对象的深复制与浅复制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o41vpeq.html">MySQL与OLAP：分析型SQL查询最佳实践探索</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp30j79.html">iOS开发 纯代码创建UICollectionView</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmxdz49.html">Hi35xx 通用GPIO 使用篇&lpar;板子3G电源控制脚说明&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8eylkej9.html">Java虚拟机-类加载</a>
			</li>
						<li><a href="https://www.batexi.com/a/950k1n68.html">SOFA 源码分析 &mdash;&mdash; 服务引用过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1j33jq.html">学习CountDownLatch</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k6xe29.html">angular2项目如何使用sass</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mxxl38.html">Mysql-单表查询的操作和注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mxg7j8.html">CSS弹性盒子的基本用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz43mw8.html">Docker 跨主机网络方案分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj344x9.html">mac终端命令及pycharm常用快捷键记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp477zq.html">C&plus;&plus;相关：部分标准库特殊设施</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zvrg59.html">10个Python练手小程序，学习python的很好的资料</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
